#ifndef CONST_INCLUDE_H
#define CONST_INCLUDE_H

#include <cmath>
typedef unsigned long long BIT64_t;

//If it's wanted to have a base-pair resolution, un-comment these lines and comment the next two.
//typedef short GEN_TYPE;
//#define GEN_SIZE 1
typedef BIT64_t GEN_TYPE;
#define GEN_SIZE 16

#define MAX_MISMATCH 3

//#define DEBUG

#define READ_BUFFER 100000

extern unsigned char bs_CONVERSION[256];
extern unsigned char gen_CONVERSION[256];
extern unsigned char INT2BASE[16];
extern int VERBOSE;
extern int MER_SIZE;
extern unsigned int BUFFER_SIZE;
extern unsigned int HASH_SIZE;
extern unsigned int MAX_HASH_SIZE;

extern float ALIGN_SCORE;
extern float ALIGN_SCORES[256][4];
extern int MAX_GAP;
extern float GAP;
extern int ADD_SIZE;
extern unsigned int BISULFITE;
extern unsigned int ATOG;

extern int BIN_SIZE;

extern char* adaptor;
extern float MIN_ADAPTOR_DIFF;
extern unsigned int MIN_CHOPPED_BASES;

enum FileType {
	CHROM=0,
	SEQUENCE=1
};

enum SeqType {
	INT=0,
	PRB=1
};

struct Read {
	unsigned int length;
	float** pwm;
};

/**********************************************
 * These next are for Command-Line Parsing
 **********************************************/
#define INVALID_ARG -1
#define NO_MATCHING_ARG -2
#define UNKNOWN_ARG -3
#define PARSE_ERROR -10

struct CMDLine {
	int errnum;
	int errpos;
};
/**********************************************/


#endif //CONST_INCLUDE_H
